FunXgame/FunXgame/Models/Marca.cs
//------------------------------------------------------------------------------
// <auto-generated>
//     Este código se generó a partir de una plantilla.
//
//     Los cambios manuales en este archivo pueden causar un comportamiento inesperado de la aplicación.
//     Los cambios manuales en este archivo se sobrescribirán si se regenera el código.
// </auto-generated>
//------------------------------------------------------------------------------

namespace FunXgame.Models
{
    using System;
    using System.Collections.Generic;
    
    public partial class Marca
    {
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]
        public Marca()
        {
            this.Marca_Categoria = new HashSet<Marca_Categoria>();
            this.Producto = new HashSet<Producto>();
        }
    
        public int Id_marca { get; set; }
        public string Codigo_marca { get; set; }
        public int Id_estado { get; set; }
        public int Id_imagen { get; set; }
        public string Nombre_marca { get; set; }
        public string Descripcion_marca { get; set; }
    
        public virtual Estado Estado { get; set; }
        public virtual Imagen Imagen { get; set; }
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Marca_Categoria> Marca_Categoria { get; set; }
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Usage", "CA2227:CollectionPropertiesShouldBeReadOnly")]
        public virtual ICollection<Producto> Producto { get; set; }
    }
}

FunXgame/FunXgame/Controllers/AdminPanelController.cs
using System;
using System.Data.Entity;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FunXgame.Models;

namespace FunXgame.Controllers
{
    
    public class AdminPanelController : Controller
    {
        // GET: AdminPerfil
        db_FunXGameEntities db = new db_FunXGameEntities();

        public ActionResult AdminPanelMenu()
        {
            return PartialView("_AdminPanelMenu");
        }

        public ActionResult AdminPerfil()
        {
            if (Session["Admin"] != null)
            {
                int id = int.Parse(Session["Id_Admin"].ToString());
                Usuario usr = db.Usuario.Find(id);
                return View(usr);
            }
            return Redirect(Url.Content("~/Home/Index/"));
        }

        [HttpPost]
        public ActionResult AdminPerfil(Usuario usr)
        {

            usr.Id_rol = 1;
            db.Entry(usr).State = EntityState.Modified;
            db.SaveChanges();

            Session.Abandon(); //---->abandona sesión para que vuelva a ingresar con 

            return Redirect(Url.Content("~/LogIn/logIn"));
        }



       





    }
}

FunXgame/FunXgame/Controllers/MarcasController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FunXgame.Models;
using System.Data.Entity;

namespace FunXgame.Controllers
{
    
    public class MarcasController : Controller
    {
        db_FunXGameEntities db = new db_FunXGameEntities();
        // GET: Marcas
        public ActionResult ListarMarca()
        {
            if (Session["Admin"] == null)
            {
                return Redirect(Url.Content("~/Home/Index/"));
            }
            ViewBag.Id_estado = new SelectList(db.Estado.Where(d => d.Id_estado == 1 || d.Id_estado == 2), "Id_estado", "Nombre_estado");
            return View();
        }

        public ActionResult ListarMarcaPartial(string codigo, string nombre, int? estado)
        {
            if (codigo == "")
            {
                codigo = null;
            }
            if (nombre == "")
            {
                nombre = null;
            }
            var lista = db.Marca.ToList();

            if (codigo != null)
            {
                lista = lista.Where(d => d.Codigo_marca.ToLower() == codigo.ToLower()).ToList();
            }
            if (nombre != null)
            {
                lista = lista.Where(d => d.Nombre_marca.ToLower() == nombre.ToLower()).ToList();
            }
            if (estado != null)
            {
                lista = lista.Where(d => d.Id_estado == estado).ToList();
            }

            return PartialView("_ListarMarcaPartial", lista);

        }

        //---------------------Agregar---------------------------

        public ActionResult CrearMarca()
        {
            ViewBag.Id_estado = new SelectList(db.Estado.Where(d => d.Id_estado == 1 || d.Id_estado == 2), "Id_estado", "Nombre_estado");
            ViewBag.Id_imagen = new SelectList(db.Imagen.Where(d => d.Id_grupo == 2), "Id_imagen", "Nombre_imagen");
            return View();
        }
        [HttpPost]
        public ActionResult CrearMarca(Marca marca)
        {
            if (Session["Admin"] == null)
            {
                return Redirect(Url.Content("~/Home/Index/"));
            }

            ViewBag.Id_estado = new SelectList(db.Estado.Where(d => d.Id_estado == 1 || d.Id_estado == 2), "Id_estado", "Nombre_estado");
            ViewBag.Id_imagen = new SelectList(db.Imagen.Where(d => d.Id_grupo == 2), "Id_imagen", "Nombre_imagen");

            db.Marca.Add(marca);
            db.SaveChanges();
            return View();
        }

        //--------------------- valida si existe ----------------------
        [HttpPost]
        public ActionResult ExisteCodigoNombreMarca(string Codigo_Marca, string Nombre_marca)
        {
            var marca = db.Marca.Where(d => d.Nombre_marca.ToLower() == Nombre_marca.ToLower()).ToList();
            if (marca.Count > 0)
            {
                return Json("nombreExiste");
            }
            var marca2 = db.Marca.Where(d => d.Codigo_marca.ToLower() == Codigo_Marca.ToLower()).ToList();
            if (marca2.Count > 0)
            {
                return Json("codigoExiste");
            }
            return Json("");
        }

        public ActionResult CargaImgPreview(int? id)
        {
            if (id != null)
            {
                Imagen imagen = db.Imagen.Find(id);
                string ruta = imagen.Ruta;
                ruta = ruta.Substring(1);
                return Json(ruta);
            }
            return Json("");
        }

        //-----------------------------------------Editar------------------------------------------------------
        public ActionResult EditarMarca(int? id)
        {
            var lista = db.Marca.Where(d => d.Id_marca == id).ToList();
            if (id == null || lista.Count==0)
            {
                return Redirect(Url.Content("~/Marcas/ListarMarca/"));
            }

            if (Session["Admin"] == null)
            {
                return Redirect(Url.Content("~/Home/Index/"));
            }

            Marca marca = db.Marca.Find(id);
            ViewBag.Id_estado = new SelectList(db.Estado.Where(d => d.Id_estado == 1 || d.Id_estado == 2), "Id_estado", "Nombre_estado", marca.Id_estado);
            ViewBag.Id_imagen = new SelectList(db.Imagen.Where(d => d.Id_grupo == 2), "Id_imagen", "Nombre_imagen", marca.Id_imagen);
            return View(marca);
        }

        [HttpPost]
        public ActionResult EditarMarca(Marca marca)
        {
            //ViewBag.Id_estado = new SelectList(db.Estado.Where(d => d.Id_estado == 1 || d.Id_estado == 2), "Id_estado", "Nombre_estado", marca.Id_estado);
            //ViewBag.Id_imagen = new SelectList(db.Imagen.Where(d => d.Id_grupo == 2), "Id_imagen", "Nombre_imagen", marca.Id_imagen);
            db.Entry(marca).State = EntityState.Modified;
            db.SaveChanges();
            return Redirect(Url.Content("~/Marcas/ListarMarca/"));
        }

        
        [HttpPost]
        public ActionResult CodigoNombreExisteEdit(string Codigo_marca, string Nombre_marca, int Id_Marca)
        {
            var marca = db.Marca.Find(Id_Marca);
            var listaMarcaA = db.Marca.Where(d => d.Nombre_marca == Nombre_marca).ToList();
            var listaMarcaB = db.Marca.Where(d => d.Codigo_marca == Codigo_marca).ToList();
            if (listaMarcaA.Count > 0 && marca.Nombre_marca.ToLower()!=Nombre_marca.ToLower())
            {
               return Json("nombreExiste");
            }
            if (listaMarcaB.Count > 0 && marca.Codigo_marca.ToLower()!=Codigo_marca.ToLower())
            {
                return Json("codigoExiste");
            }
            return Json("");
        }


        public ActionResult EstadoMarca(int id)
        {
            var marca = db.Marca.Find(id);
            if (marca.Id_estado == 1)
            {
                marca.Id_estado = 2;
                db.Entry(marca).State = EntityState.Modified;
            }
            else
            {
                marca.Id_estado = 1;
                db.Entry(marca).State = EntityState.Modified;
            }
            db.SaveChanges();
            return Redirect(Url.Content("~/Marcas/ListarMarca"));
        }

    }
}

FunXgame/FunXgame/Views/Marcas/CrearMarca.cshtml
@model FunXgame.Models.Marca

@{
    ViewBag.Title = "CrearMarca";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="card text-center" style="background-color:whitesmoke">

    @{Html.RenderAction("AdminPanelMenu", "AdminPanel");}

    <div class="card-body">
        <div class="card text-left" style="background-color:whitesmoke">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs">
                    <li class="nav-item">
                        <a class="nav-link " style="color:black" href="~/Marcas/ListarMarca">Listar Marcas</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link active" style="color:white; background-color:black" href="#">Agregar Marca</a>
                    </li>
                </ul>
            </div>
            <div class="card-body text-left">
                @using (Html.BeginForm("CrearMarca", "Marcas", FormMethod.Post, new { role = "form", id = "marcaCreaForm", @class = "" }))
                {
                    @Html.AntiForgeryToken()

                    <div class="form-horizontal">

                        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                        <div class="form-group">

                            <div class="col-md-10">
                                <label>Código:</label>
                                @Html.EditorFor(model => model.Codigo_marca, new { htmlAttributes = new { @class = "form-control",id="Codigo_marca" } })
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-10">
                                <label>Estado:</label>
                                @Html.DropDownList("Id_estado", null,"Seleccione...", htmlAttributes: new { @class = "form-control", id ="Id_estado"})
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-10">
                                <img id=img src="~/Content/Assets/Imagenes/noImage.jpg" style="width:280px" />
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-10">
                                <label>Seleccione imagen:</label>
                                @Html.DropDownList("Id_imagen", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "img_select" })
                            </div>
                        </div>

                        <div class="form-group">

                            <div class="col-md-10">
                                <label>Nombre:</label>
                                @Html.EditorFor(model => model.Nombre_marca, new { htmlAttributes = new { @class = "form-control", id="Nombre_marca" } })

                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-md-10">
                                <label>Descripción:</label>
                                @Html.EditorFor(model => model.Descripcion_marca, new { htmlAttributes = new { @class = "form-control", id="Descripcion_marca" } })
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-offset-2 col-md-10">
                                <input id="btnGuardar" type="submit" value="Agregar marca" class="btn btn-dark" />
                            </div>
                        </div>
                    </div>
                }

            </div>
        </div>
    </div>
</div>




@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="~/Scripts/sweetalert.js"></script>
    <script src="~/Scripts/Validaciones/valida_marca.js"></script>

    <script>

        

        $(document).ready(function () {

            $('#Codigo_marca').blur(function () {
                validaCodigoNombreExiste('#Codigo_marca');
            });
            $('#Nombre_marca').blur(function () {
                validaCodigoNombreExiste('#Nombre_marca');
            });
           
            enviaValidaMarca('Nueva marca creada', '#marcaCreaForm')
            limpiar();
        })

        function limpiar() {
            $('#Codigo_marca').val('');
            $('#img_select').val('');
            $('#Nombre_marca').val('');
            $('#Id_estado').val('');
            $('#Descripcion_marca').val('');
        }
       

        $('#img_select').change(function () {
            $.ajax({
                type: 'POST',
                url: '@Url.Action("CargaImgPreview")',
                data: '{id:' + JSON.stringify($('#img_select').val()) + '}',
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                success: function (result) {
                    if (result != "") {
                        $('#img').attr('src', result);
                        preview.style.display = "block";
                    }
                }
            });
        });

        function validaCodigoNombreExiste(selector) {

            var valores = { Codigo_marca: $('#Codigo_marca').val().trim(), Nombre_marca: $('#Nombre_marca').val() };
            var resultado = JSON.stringify(valores);

            if ($(selector).val().trim() != '') {
                    $.ajax({
                        type: 'POST',
                        url: '@Url.Action("ExisteCodigoNombreMarca")',
                        data: resultado,
                        dataType: 'json',
                        contentType: 'application/json; charset=utf-8',
                        success: function (result) {
                            if (result == "codigoExiste") {
                                $('#Codigo_marca').val('');
                                swal("Ya existe una marca con ese código", "", "warning");
                            }

                            if (result == "nombreExiste") {
                                $('#Nombre_marca').val('');
                                swal("Ya existe una marca con ese nombre", "", "warning");
                            }
                        }
                    });
            }
        }
    </script>


}

FunXgame/FunXgame/Views/Marcas/EditarMarca.cshtml

@model FunXgame.Models.Marca

@{
    ViewBag.Title = "EditarMarca";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="card text-center" style="background-color:whitesmoke">

    @{Html.RenderAction("AdminPanelMenu", "AdminPanel");}

    <div class="card-body">
        <div class="card text-left" style="background-color:whitesmoke">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs">
                    <li class="nav-item">
                        <a class="nav-link " style="color:black" href="~/Marcas/ListarMarca">Listar Marcas</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" style="color:black" href="~/Marcas/CrearMarca">Agregar Marca</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link active" style="color:white; background-color:black" href="#">Editar Marca</a>
                    </li>
                </ul>
            </div>
            <div class="card-body text-left">
                @using (Html.BeginForm("EditarMarca", "Marcas", FormMethod.Post, new { role = "form", id = "marcaEditaForm", @class = "" }))
                {
                    @Html.AntiForgeryToken()

                <div class="form-horizontal">
                    <input id="Id_Marca" name="Id_marca" type="text" value="@Model.Id_marca" hidden />

                    @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                    <div class="form-group">

                        <div class="col-md-10">
                            <label>Código:</label>
                            @Html.EditorFor(model => model.Codigo_marca, new { htmlAttributes = new { @class = "form-control", id = "Codigo_marca" } })
                        </div>
                    </div>

                    <div class="form-group" style="display:none">
                        <div class="col-md-10">
                            <label>Estado:</label>
                            @Html.DropDownList("Id_estado", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "Id_estado" })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <img id=img src="~/Content/Assets/Imagenes/noImage.jpg" style="width:280px" />
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Seleccione imagen:</label>
                            @Html.DropDownList("Id_imagen", null, "Seleccione...", htmlAttributes: new { @class = "form-control", id = "img_select" })
                        </div>
                    </div>

                    <div class="form-group">

                        <div class="col-md-10">
                            <label>Nombre:</label>
                            @Html.EditorFor(model => model.Nombre_marca, new { htmlAttributes = new { @class = "form-control", id = "Nombre_marca" } })

                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-md-10">
                            <label>Descripción:</label>
                            @Html.EditorFor(model => model.Descripcion_marca, new { htmlAttributes = new { @class = "form-control", id = "Descripcion_marca" } })
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-offset-2 col-md-10">
                            <input id="btnGuardar" type="submit" value="Actualizar marca" class="btn btn-dark" />
                        </div>
                    </div>
                </div>
                }

            </div>
        </div>
    </div>
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="~/Scripts/sweetalert.js"></script>
    <script src="~/Scripts/Validaciones/valida_marca.js"></script>

    <script>

        $(window).on("load", function () {
            cargaImgPrev();
        });

        $('#img_select').change(function () {
            cargaImgPrev();
        });

        $(document).ready(function () {

            $('#Codigo_marca').blur(function () {
                codigoMarcaRepetidos('#Codigo_marca');
            });
            $('#Nombre_marca').blur(function () {
                
                codigoMarcaRepetidos('#Nombre_marca');
            });

            enviaValidaMarca('Marca actualizada', '#marcaEditaForm')
        })

        function cargaImgPrev() {
            $.ajax({
                type: 'POST',
                url: '@Url.Action("CargaImgPreview")',
                data: '{id:' + JSON.stringify($('#img_select').val()) + '}',
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                success: function (result) {
                    if (result != "") {
                        $('#img').attr('src', result);
                        preview.style.display = "block";
                    }
                }
            });
        }

        
        function codigoMarcaRepetidos(selector) {
            var valores = { Codigo_marca: $('#Codigo_marca').val().trim(), Nombre_marca: $('#Nombre_marca').val(), Id_Marca: $('#Id_Marca').val() };
            var resultado = JSON.stringify(valores);

            if ($(selector).val().trim() != '') {

                $.ajax({
                type: 'POST',
                url: '@Url.Action("CodigoNombreExisteEdit")',
                data: resultado,
                dataType: 'json',
                contentType: 'application/json; charset=utf-8',
                success: function (result) {
                    if (result == "nombreExiste") {
                        swal("Ya existe otra marca con ese nombre", "", "warning");
                        $('#Nombre_marca').val('');
                    }
                    if (result == "codigoExiste") {
                        swal("Ya existe una marca con ese código", "", "warning");
                        $('#Codigo_marca').val('');
                    }
                }
                });
            }
        }
    </script>

}

FunXgame/FunXgame/Views/Marcas/ListarMarca.cshtml

@model IEnumerable<FunXgame.Models.Marca>
@{
    ViewBag.Title = "ListarMarca";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<div class="card text-center" style="background-color:whitesmoke">
    @{Html.RenderAction("AdminPanelMenu", "AdminPanel");}


    <div class="card-body">
        <div class="card text-left" style="background-color:whitesmoke">
            <div class="card-header">
                <ul class="nav nav-tabs card-header-tabs">

                    <li class="nav-item">
                        <a class="nav-link " style="color:white;background-color:black" href="~/Marcas/ListarMarca">Listar Marca</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link " style="color:black" href="~/Marcas/CrearMarca">Agregar Marca</a>
                    </li>
                </ul>
            </div>
            <div class="card-body">
                <!--SELECTOR FILTROS-->
                <div class="form-row">
                    <div class="col-3 form-group">
                        <input class="form-control" type="text" id="Codigo_marca" value="" placeholder="Codigo Marca" />
                    </div>
                    <div class="col-3 form-group">
                        <input class="form-control" type="text" id="Nombre_marca" value="" placeholder="Nombre Marca" />
                    </div>
                    <div class="col-3 form-group">
                        @Html.DropDownList("Id_estado", null, "Todos", htmlAttributes: new { @class = "form-control", id = "Id_estado" })
                    </div>

                    <div>
                        <button class="btn btn-dark" id="buscar">Buscar</button>
                    </div>
                </div>
                <div class="table-responsive" id="tablaMarca">
                    <!--AQUI PARA FUNCION LISTADO VISTA PARCIAL-->
                    <!--ESTO VA EN VISTA PARCIAL-->

                </div>
            </div>
        </div>
    </div>
</div>


@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
    <script src="~/Scripts/sweetalert.js"></script>
    <script>

         $(window).on("load", function () {
             cargaTablaMarca();
         });

        $('#buscar').click(function () {
            cargaTablaMarca();
            $(this).blur();
        });

        function cargaTablaMarca() {
            let datos = '?codigo=' + $('#Codigo_marca').val() + '&nombre=' + $('#Nombre_marca').val() + '&estado=' + $('#Id_estado').val();
                $.get('@Url.Action("ListarMarcaPartial")' + datos, function (lista) {
                    $('#tablaMarca').html(lista);
                });
        }


    </script>
}

FunXgame/FunXgame/Views/Marcas/_ListarMarcaPartial.cshtml
@model IEnumerable<FunXgame.Models.Marca>


<table class="table">
    <tr>
        <th>
            <label>Código</label>
        </th>
        <th>
            <label>Nombre</label>
        </th>

        <th>
            <label>Estado</label>
        </th>
        <th>

            <label>Imagen</label>
        </th>
        <th></th>
    </tr>

    @foreach (var item in Model)
    {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.Codigo_marca)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Nombre_marca)
            </td>

            <td>
                @Html.DisplayFor(modelItem => item.Estado.Nombre_estado)
                
            </td>

            <td>

                <img src="@Url.Content(item.Imagen.Ruta) " style="height:80px" />
            </td>


            <td>
                @{
                    string texto = "";
                    string idBtn = item.Id_marca.ToString();
                    int estado = item.Id_estado;
                    if (estado == 1)
                    {
                        texto = "Desactivar";
                    }
                    else
                    {
                        texto = "Activar";
                    }
                }
                <a class="btn btn-success" href="~/Marcas/EditarMarca/@item.Id_marca" id="" style="width:100px">Editar</a>
                <a class="btn btn-secondary" href="~/Marcas/EstadoMarca/@item.Id_marca" id="" style="width:100px">@texto</a>
            </td>
        </tr>
    }

</table>

